///////////////////////////////////////////////////////////
/// Fonctions de gestion d'une colonne date
///////////////////////////////////////////////////////////
var dateproprecolumnHandler =
{
	/////////////////////////////////////////////////////////
	/// Texte à afficher
	/////////////////////////////////////////////////////////
	getCellText:
		function(row,col)
		{
			var key = gDBView.getKeyAt(row);
			var hdr = gDBView.db.GetMsgHdrForKey(key);
	
			var date = new Date(hdr.dateInSeconds * 1000);
			return FormatCleanDate(date);
		}

	/////////////////////////////////////////////////////////
	/// Critère de tri, en texte
	/////////////////////////////////////////////////////////
,	getSortStringForRow:
		function(hdr)
		{
/*
			var date = new Date(hdr.dateInSeconds * 1000);
			var Key = ApplyFormat("yyyymmddHHMMSS",date);
			dump(Key);
			return Key;
/*/
			return null;
/**/
		}

	/////////////////////////////////////////////////////////
	/// Est-ce une colonne texte ?
	/////////////////////////////////////////////////////////
,	isString:
		function()
		{
			return true;
		}

	/////////////////////////////////////////////////////////
	/// Propriétés de la cellule
	/////////////////////////////////////////////////////////
,	getCellProperties:
		function(row, col, props)
		{
		}

	/////////////////////////////////////////////////////////
	/// Propriétés de la ligne
	/////////////////////////////////////////////////////////
,	getRowProperties:
		function(row, props)
		{
			/////////////////////////////////////////////////////////
			/// Attribuer un style si le courriel vient du futur
			/////////////////////////////////////////////////////////
			var key = gDBView.getKeyAt(row);
			var hdr = gDBView.db.GetMsgHdrForKey(key);
	
			var date = new Date(hdr.dateInSeconds * 1000);
			var now = new Date();
			if (date.getTime() > now.getTime())
			{
				var aserv = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
				props.AppendElement(aserv.getAtom("FromTheFuture"));
			}
		}

	/////////////////////////////////////////////////////////
	/// Image à afficher dans la colonne
	/////////////////////////////////////////////////////////
,	getImageSrc:
		function(row, col)
		{
			return null;
		}

	/////////////////////////////////////////////////////////
	/// Critère de tri, en numérique
	/////////////////////////////////////////////////////////
,	getSortLongForRow:
		function(hdr)
		{
			return gDBView.getColumnHandler("dateCol").getSortLongForRow(hdr);
		}
}

var datepropreCreateDbObserver =
{
	// Components.interfaces.nsIObserver
	observe:
		function(aMsgFolder, aTopic, aData)
		{  
			gDBView.addColumnHandler("dateCol", dateproprecolumnHandler);
		}
}

var dateproprePrefObserver =
{
	// Components.interfaces.nsIPrefService
	register:
		function()
		{
			var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			this._branch = prefService.getBranch(Config);
			this._branch = this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
			this._branch.addObserver("", this, false);
		}

,	unregister:
		function()
		{
			if (this._branch)
			{
				this._branch.removeObserver("", this);
			}
		}
,	observe:
		function(aSubject, aTopic, aData)
		{
			if (aTopic == "nsPref:changed") 
			{
				var tree = document.getElementById( "threadTree" );
				if (typeof tree == "object")
				{
					tree.treeBoxObject.invalidateColumn(tree.columns["dateCol"]);
				}
			}
		}
};

function datepropreOnLoadWindow()
{
	var ObserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	ObserverService.addObserver(datepropreCreateDbObserver, "MsgCreateDBView", false);

	dateproprePrefObserver.register();
}

window.addEventListener("load", datepropreOnLoadWindow, true);

