///////////////////////////////////////////////////////////
/// Fonctions de formatage de dates
/// NOTHING TO TRANSLATE HERE
/// RIEN À TRADUIRE ICI
///////////////////////////////////////////////////////////
const Config = "extensions.datepropre.";
const List = [ "Today", "24h", "Yesterday", "7days", "ThisMonth", "Month", "6months", "ThisYear", "Year" ];

///////////////////////////////////////////////////////////
/// Applique le bon format à une date
///////////////////////////////////////////////////////////
function FormatCleanDate(SomeDate)
{
	var Fmt = GetFormat(SomeDate);
	if ("" == Fmt)
	{
		var DefStd = nsPreferences.getIntPref("mail.ui.display.dateformat.default",2);
		switch (DefStd)
		{
			case 0:
			{
				Fmt = "HH\\:MM";
			}
			break;
			case 1:
			{
				Fmt = "dddd\\ d\\ mmmm\\ yyyy\\ HH\\:MM";
			}
			break;
			case 2:
			default:
			{
				Fmt = "dd\\-mm\\-yyyy\\ HH\\:MM";
			}
			break;
			case 3:
			{
				Fmt = "yyy\\/mm HH\\:MM";
			}
			break;
			case 4:
			{
				Fmt = "ddd\\ HH\\:MM";
			}
			break;
		}
	}
	return ApplyFormat(Fmt,SomeDate);
}

///////////////////////////////////////////////////////////
/// Trouve le bon format pour une date
///////////////////////////////////////////////////////////
function GetFormat(SomeDate)
{

	const OneDay = 24 * 60 * 60 * 1000;

	var SomeDay = new Date(SomeDate.getFullYear(),SomeDate.getMonth(),SomeDate.getDate(),0,0,0);

	var Now = new Date();
	var Today = new Date(Now.getFullYear(),Now.getMonth(),Now.getDate(),0,0,0);
	var Yesterday = new Date(Today.getTime() - OneDay);

	if (Today.getTime() == SomeDay.getTime())
	{
		// Today
		if (nsPreferences.getBoolPref(Config + List[0] + "Enabled", false))
		{
			return nsPreferences.copyUnicharPref(Config + List[0] + "Format", "");
		}
	}

	if (SomeDate.getTime() <= Now.getTime())
	{
		// Must be in the past

		if (SomeDate.getTime() > Now.getTime() - OneDay)
		{
			// 24h
			if (nsPreferences.getBoolPref(Config + List[1] + "Enabled", false))
			{
				return nsPreferences.copyUnicharPref(Config + List[1] + "Format", "");
			}
		}

		if (SomeDay.getTime() == Yesterday.getTime())
		{
			// Yesterday
			if (nsPreferences.getBoolPref(Config + List[2] + "Enabled", false))
			{
				return nsPreferences.copyUnicharPref(Config + List[2] + "Format", "");
			}
		}

		if (SomeDate.getTime() > Today.getTime() - 6 * OneDay)
		{
			// 7days
			if (nsPreferences.getBoolPref(Config + List[3] + "Enabled", false))
			{
				return nsPreferences.copyUnicharPref(Config + List[3] + "Format", "");
			}
		}

		if ((SomeDay.getFullYear() == Today.getFullYear())
		&&  (SomeDay.getMonth() == Today.getMonth()))
		{
			// ThisMonth
			if (nsPreferences.getBoolPref(Config + List[4] + "Enabled", false))
			{
				return nsPreferences.copyUnicharPref(Config + List[4] + "Format", "");
			}
		}

		Limit = SubtractMonth(Today,1);
		if (SomeDate.getTime() >= Limit.getTime())
		{
			// 1month
			if (nsPreferences.getBoolPref(Config + List[5] + "Enabled", false))
			{
				return nsPreferences.copyUnicharPref(Config + List[5] + "Format", "");
			}
		}

		Limit = SubtractMonth(Today,6);
		if (SomeDate.getTime() >= Limit.getTime())
		{
			// 6months
			if (nsPreferences.getBoolPref(Config + List[6] + "Enabled", false))
			{
				return nsPreferences.copyUnicharPref(Config + List[6] + "Format", "");
			}
		}

		if (SomeDay.getFullYear() == Today.getFullYear())
		{
			// ThisYear
			if (nsPreferences.getBoolPref(Config + List[7] + "Enabled", false))
			{
				return nsPreferences.copyUnicharPref(Config + List[7] + "Format", "");
			}
		}

		Limit = SubtractMonth(Today,12);
		if (SomeDate.getTime() > Limit.getTime() + OneDay)
		{
			// 1year
			if (nsPreferences.getBoolPref(Config + List[8] + "Enabled", false))
			{
				return nsPreferences.copyUnicharPref(Config + List[8] + "Format", "");
			}
		}
	}

	return nsPreferences.copyUnicharPref(Config + "DefaultFormat", "");
}

///////////////////////////////////////////////////////////
/// Soustrait N mois à une date
///////////////////////////////////////////////////////////
function SubtractMonth(SomeDate,N)
{
	var Year = SomeDate.getFullYear();
	var Month = SomeDate.getMonth();
	var Day = SomeDate.getDate();
	Month -= N;
	if (Month < 0)
	{
		Month += 12;
		--Year;
	}
	var Temp = new Date(Year,Month,Day);
	while (Month != Temp.getMonth())
	{
		--Day;
		Temp = new Date(Year,Month,Day);
	}
	return new Date(Year,Month,Day + 1);
}

///////////////////////////////////////////////////////////
/// Applique un format à une date
/// i Format   : Chaîne de format
/// i SomeDate : Date à formater
/// retour     : Chaîne formatée
///////////////////////////////////////////////////////////
function ApplyFormat(Format,SomeDate)
{
	var Known = "dmyhHMSpP";
	var String = "";

	var Length = Format.length;
	var Fmt = "";
	var Width = 0;
	var QuotedStart = Length;
	var Escaped = false;
	for (var i = 0; i < Length; ++i)
	{
		var Current = Format.charAt(i);
		if (Escaped)
		{
			String += Current;
			Escaped = false;
		}
		else if (("\\" == Current) && (QuotedStart >= i))
		{
			String += ProcessFmt(Fmt,Width,SomeDate);
			Width = 0;
			Fmt = "";
			Escaped = true;
		}
		else if ("\"" == Current)
		{
			if (QuotedStart + 1 == i)
			{
				String += "\"";
				QuotedStart = Length;
			}
			else if (QuotedStart < i)
			{
				String += Format.substring(QuotedStart + 1,i);
				QuotedStart = Length;
			}
			else
			{
				QuotedStart = i;
				String += ProcessFmt(Fmt,Width,SomeDate);
				Width = 0;
				Fmt = "";
			}
		}
		else if (QuotedStart >= i)
		{
			if (Known.indexOf(Current) >= 0)
			{
				if (Current == Fmt)
				{
					++Width;
				}
				else
				{
					String += ProcessFmt(Fmt,Width,SomeDate);
					Width = 1;
					Fmt = Current;
				}
			}
			else
			{
				String += ProcessFmt(Fmt,Width,SomeDate);
				Width = 0;
				Fmt = "";
			}
		}
	}
	String += ProcessFmt(Fmt,Width,SomeDate);

	return String;
}

///////////////////////////////////////////////////////////
/// Applique un élément de format à une date
/// i Fmt      : Lettre de format
/// i Width    : Largeur du format (répétition de la lettre)
/// i SomeDate : Date à formater
/// retour     : Chaîne formatée
///////////////////////////////////////////////////////////
function ProcessFmt(Fmt,Width,SomeDate)
{
	var String = "";

	var ShortDay = [ "sSun", "sMon", "sTue", "sWed", "sThu", "sFri", "sSat" ];
	var LongDay = [ "lSun", "lMon", "lTue", "lWed", "lThu", "lFri", "lSat" ];
	var ShortMonth = [ "sJan", "sFeb", "sMar", "sApr", "sMay", "sJun", "sJul", "sAug", "sSep", "sOct", "sNov", "sDec" ];
	var LongMonth = [ "lJan", "lFeb", "lMar", "lApr", "lMay", "lJun", "lJul", "lAug", "lSep", "lOct", "lNov", "lDec" ];

	if ("d" == Fmt)
	{
		switch (Width)
		{
			case 1:
			{
				String = "" + SomeDate.getDate();
			}
			break;
			case 2:
			{
				var Temp = "0" + SomeDate.getDate();
				String = Temp.substr(Temp.length - 2,2);
			}
			break;
			case 3:
			{
				var Bundle = document.getElementById("datepropreAllStrings");
				var Id = ShortDay[SomeDate.getDay()];
				if (Bundle == null)
				{
					String = document.getElementById(Id).innerHTML;
				}
				else
				{
					String = Bundle.getString(Id);
				}
			}
			break;
			default:
			{
				var Id = LongDay[SomeDate.getDay()];
				var Bundle = document.getElementById("datepropreAllStrings");
				if (Bundle == null)
				{
					String = document.getElementById(Id).innerHTML;
				}
				else
				{
					String = Bundle.getString(Id);
				}
			}
			break;
		}
	}
	else if ("m" == Fmt)
	{
		switch (Width)
		{
			case 1:
			{
				String = "" + (1 + SomeDate.getMonth());
			}
			break;
			case 2:
			{
				var Temp = "0" + (1 + SomeDate.getMonth());
				String = Temp.substr(Temp.length - 2,2);
			}
			break;
			case 3:
			{
				var Id = ShortMonth[SomeDate.getMonth()];
				var Bundle = document.getElementById("datepropreAllStrings");
				if (Bundle == null)
				{
					String = document.getElementById(Id).innerHTML;
				}
				else
				{
					String = Bundle.getString(Id);
				}
			}
			break;
			default:
			{
				var Bundle = document.getElementById("datepropreAllStrings");
				var Id = LongMonth[SomeDate.getMonth()];
				if (Bundle == null)
				{
					String = document.getElementById(Id).innerHTML;
				}
				else
				{
					String = Bundle.getString(Id);
				}
			}
			break;
		}
	}
	else if ("y" == Fmt)
	{
		var Temp = "0000" + SomeDate.getFullYear();
		switch (Width)
		{
			case 2:
			{
				String = Temp.substr(Temp.length - 2,2);
			}
			break;
			default:
			{
				String = Temp.substr(Temp.length - 4,4);
			}
			break;
		}
	}
	else if ("h" == Fmt)
	{
		var Temp = SomeDate.getHours() % 12;
		if (0 == Temp)
			Temp = 12;
		if (1 == Width)
			String = Temp;
		else
		{
			Temp = "00" + Temp;
			String = Temp.substr(Temp.length - 2,2);
		}
	}
	else if ("H" == Fmt)
	{
		if (1 == Width)
			String = SomeDate.getHours();
		else
		{
			Temp = "00" + SomeDate.getHours();
			String = Temp.substr(Temp.length - 2,2);
		}
	}
	else if ("M" == Fmt)
	{
		if (1 == Width)
			String = SomeDate.getMinutes();
		else
		{
			Temp = "00" + SomeDate.getMinutes();
			String = Temp.substr(Temp.length - 2,2);
		}
	}
	else if ("S" == Fmt)
	{
		if (1 == Width)
			String = SomeDate.getSeconds();
		else
		{
			Temp = "00" + SomeDate.getSeconds();
			String = Temp.substr(Temp.length - 2,2);
		}
	}
	else if ("p" == Fmt)
	{
		var AM = SomeDate.getHours() < 12;
		switch (Width)
		{
			case 1:
			{
				String = AM ? "am1" : "pm1";
			}
			break;
			case 2:
			{
				String = AM ? "am2" : "pm2";
			}
			break;
			default:
			{
				String = AM ? "am" : "pm";
			}
			break;
		}
		var Bundle = document.getElementById("datepropreAllStrings");
		if (Bundle != null)
		{
			String = Bundle.getString(String);
		}
		else
		{
			String = document.getElementById(String).innerHTML;
		}
	}
	else if ("P" == Fmt)
	{
		var AM = SomeDate.getHours() < 12;
		switch (Width)
		{
			case 1:
			{
				String = AM ? "AM1" : "PM1";
			}
			break;
			case 2:
			{
				String = AM ? "AM2" : "PM2";
			}
			break;
			default:
			{
				String = AM ? "AM" : "PM";
			}
			break;
		}
		var Bundle = document.getElementById("datepropreAllStrings");
		if (Bundle != null)
		{
			String = Bundle.getString(String);
		}
		else
		{
			String = document.getElementById(String).innerHTML;
		}
	}

	return String;
}

function LoadHelp()
{
	var Date1 = new Date(1999,11,31,23,39,59);
	var Date2 = new Date(2005,6,4,9,5,3);
	document.getElementById("SampleA0").innerHTML = Date1.toString();
	document.getElementById("SampleB0").innerHTML = Date2.toString();
	for (var i = 1; i <= 8; ++i)
	{
		try
		{
			var Fmt = document.getElementById("Format" + i).innerHTML;
			document.getElementById("SampleA" + i).innerHTML = ApplyFormat(Fmt,Date1);
			document.getElementById("SampleB" + i).innerHTML = ApplyFormat(Fmt,Date2);
		}
		catch (ex)
		{
		}
	}
}
