///////////////////////////////////////////////////////////
/// Fonctions de formatage de dates
///////////////////////////////////////////////////////////

var SomeDate = new Date();

///////////////////////////////////////////////////////////
/// Chargement de la fentre des options
///////////////////////////////////////////////////////////
function onOptionsLoad()
{
	for (var i = 0; i < List.length; ++i)
	{
		var Item = List[i];
		var IsChecked = nsPreferences.getBoolPref(Config + Item + "Enabled", false);
		var Format = nsPreferences.copyUnicharPref(Config + Item + "Format", "");

		document.getElementById("options" + Item + "Enabled").checked = IsChecked;
		document.getElementById("options" + Item + "Format").value = Format;
		document.getElementById("options" + Item + "Format").disabled = ! IsChecked;

		document.getElementById("options" + Item + "Sample").value = IsChecked ? ApplyFormat(Format,SomeDate) : "";

		document.getElementById("options" + Item + "Enabled").addEventListener( "command", EnableFormat, false );
		document.getElementById("options" + Item + "Format").addEventListener( "input", UpdateSample, false );
	}

	var Format = nsPreferences.copyUnicharPref(Config + "DefaultFormat", "");

	document.getElementById("optionsDefaultFormat").value = Format;
	document.getElementById("optionsDefaultSample").value = ApplyFormat(Format,SomeDate);

	document.getElementById("optionsDefaultFormat").addEventListener( "input", UpdateSample, false );

	return true;
}

///////////////////////////////////////////////////////////
/// Active un champ de format (selon case  cocher)
///////////////////////////////////////////////////////////
function EnableFormat(Event)
{
	var Source = Event.target.id;
	if ((Source.substr(0,7) == "options")
	&&  (Source.substr(Source.length - 7,7) == "Enabled"))
	{
		var Prefix = Source.substr(0,Source.length - 7);
		document.getElementById(Prefix + "Format").disabled = ! Event.target.checked;
		Target = Source.substr(0,Source.length - 7) + "Sample";
		document.getElementById(Prefix + "Sample").value = Event.target.checked
		                                                 ? ApplyFormat(document.getElementById(Prefix + "Format").value,SomeDate)
																										 : "";
	}
}

///////////////////////////////////////////////////////////
/// Met  jour un exemple (selon format)
///////////////////////////////////////////////////////////
function UpdateSample(Event)
{
	var Source = Event.target.id;
	if ((Source.substr(0,7) == "options")
	&&  (Source.substr(Source.length - 6,6) == "Format"))
	{
		var Prefix = Source.substr(0,Source.length - 6);
		var Enabled = ("optionsDefault" == Prefix) || document.getElementById(Prefix + "Enabled").checked;
		document.getElementById(Prefix + "Sample").value = Enabled
		                                                 ? ApplyFormat(document.getElementById(Prefix + "Format").value,SomeDate)
																										 : "";
	}
}

///////////////////////////////////////////////////////////
/// Sortie (valide) de la fentre des options
///////////////////////////////////////////////////////////
function onOptionsAccept()
{
	for (var i = 0; i < List.length; ++i)
	{
		var Item = List[i];

		nsPreferences.setBoolPref(Config + Item + "Enabled"
		                         ,document.getElementById("options" + Item + "Enabled").checked);
		nsPreferences.setUnicharPref(Config + Item + "Format"
		                            ,document.getElementById("options" + Item + "Format").value);
	}
	nsPreferences.setUnicharPref(Config + "DefaultFormat"
	                            ,document.getElementById("optionsDefaultFormat").value);

	return true;
}

///////////////////////////////////////////////////////////
/// Sortie (annulation) de la fentre des options
///////////////////////////////////////////////////////////
function onOptionsCancel()
{
	return true;
}

///////////////////////////////////////////////////////////
/// Bouton d'aide
///////////////////////////////////////////////////////////
function onOptionsHelp()
{
	window.open("chrome://datepropre/content/help.xul","help","chrome");
	return true;
}
